package djmil.cordacheckers.cordaclient.dao;

import java.util.List;

public class GameBoardCommand {
    public static enum Type {
        MOVE,
        SURRENDER,
        DRAW,
        VICTORY,
        ACCEPT;
    }

    private final Type type;
    private final List<Integer> move; // [0] from, [1] to
    
    public GameBoardCommand() {
        this.type = null;
        this.move = null;
    }

    public GameBoardCommand(Type type) {
        this.type = type;
        this.move = null;
    }

    public GameBoardCommand(List<Integer> move) {
        this.type = Type.MOVE;
        this.move = move;
    }

    public Type getType() {
        return type;
    }

    public List<Integer> getMove() {
        return move;
    }

    @Override
    public String toString() {
        if (type == Type.MOVE) 
            return move.get(0) +"->" +move.get(1);
        else
            return type.name();
    }

}
