package djmil.cordacheckers.contracts;

import static djmil.cordacheckers.contracts.UtxoLedgerTransactionUtil.getSingleCommand;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import net.corda.v5.base.exceptions.CordaRuntimeException;
import net.corda.v5.ledger.utxo.transaction.UtxoLedgerTransaction;

import static djmil.cordacheckers.contracts.UtxoLedgerTransactionUtil.requireThat;

public class GameResultContract implements net.corda.v5.ledger.utxo.Contract {

    private final static Logger log = LoggerFactory.getLogger(GameResultContract.class);

    @Override
    public void verify(UtxoLedgerTransaction trx) {
        log.info("GameResultContract.verify() called");

        requireThat(trx.getCommands().size() == 1, REQUIRE_SINGLE_COMMAND);
        final GameBoardCommand command = getSingleCommand(trx, GameBoardCommand.class);

        switch (command.getType()) {
            case SURRENDER: 
                GameBoardCommand.validateSurrenderTrx(trx);
            break;

            // case ACCEPT:
            // break;

            default:
                throw new CordaRuntimeException(UNKNOWN_COMMAND);
        }
    }
    
    static final String REQUIRE_SINGLE_COMMAND = "Require a single command";
    static final String UNKNOWN_COMMAND = "Unsupported command";
}
