package djmil.cordacheckers.gameresult;

import java.util.UUID;

import djmil.cordacheckers.states.GameResultState;
import djmil.cordacheckers.states.Piece;

public class GameResultView {
    public final String whitePlayerName;
    public final String blackPlayerName;
    public final Piece.Color victoryColor;
    public final UUID id;

    // Serialisation service requires a default constructor
    public GameResultView() {
        this.whitePlayerName = null;
        this.blackPlayerName = null;
        this.victoryColor = null;
        this.id = null;
    }

    public GameResultView(GameResultState gameResultState) {
        this.whitePlayerName = gameResultState.getWhitePlayerName().getCommonName();
        this.blackPlayerName = gameResultState.getBlackPlayerName().getCommonName();
        this.victoryColor = gameResultState.getVictoryColor();
        this.id = gameResultState.getId();
    }

}
